Index: trunk/zoo-project/zoo-kernel/zoo_service_loader.c
===================================================================
--- trunk/zoo-project/zoo-kernel/zoo_service_loader.c	(revision 966)
+++ trunk/zoo-project/zoo-kernel/zoo_service_loader.c	(revision 967)
@@ -419,5 +419,5 @@
   
   map* errormap = createMap("text", tmp01);
-  map* tmpMap=getMapFromMaps(m,"lenv","executionType");
+  map* tmpMap=getMapFromMaps(m,"main","executionType");
   char* errorCode=(char*)code;
   if(tmpMap!=NULL && strncasecmp(tmpMap->value,"json",4)==0)
@@ -1888,11 +1888,11 @@
   maps *request_input_real_format = NULL;
 
-  setMapInMaps(m,"lenv","executionType","xml");
+  setMapInMaps(m,"main","executionType","xml");
   if((strlen(cgiQueryString)>0 && cgiQueryString[0]=='/') /*&& strstr(cgiAccept,"json")!=NULL*/){
     //
-    // OGC API - Processing starts here
+    // OGC API - Processes starts here
     //
 #ifndef USE_JSON
-    errorException (m, _("OGC API - Processing is not supported by this ZOO-Kernel."), "InternalError", NULL);
+    errorException (m, _("OGC API - Processes is not supported by this ZOO-Kernel, please contact the service provider."), "InternalError", NULL);
     return 1;
 #else
@@ -1908,4 +1908,5 @@
     signal (SIGABRT, json_sig_handler);
 #endif
+    setMapInMaps(m,"main","executionType","json");
     r_inputs = getMapOrFill (&request_inputs, "metapath", "");
     char conf_file1[10240];
@@ -1920,7 +1921,5 @@
       }
     addMapsToMaps(&m,m1);
-    setMapInMaps(m,"lenv","executionType","json");
     map* pmTmp0=getMapFromMaps(m,"openapi","full_html_support");
-    dumpMap(pmTmp0);
     if(strstr(cgiQueryString,".html")==NULL && strstr(cgiAccept,"text/html")!=NULL && pmTmp0!=NULL && strncasecmp(pmTmp0->value,"true",4)==0){
       map* pmTmpUrl=getMapFromMaps(m,"openapi","rootUrl");
@@ -2305,28 +2304,5 @@
 		}else{
 		  char* jobId=zStrdup(strstr(cgiQueryString,"/jobs/")+6);
-		  runGetStatus(m,jobId,"GetStatus");
-		  map* pmError=getMapFromMaps(m,"lenv","error");
-		  if(pmError!=NULL && strncasecmp(pmError->value,"true",4)==0){
-		    printExceptionReportResponseJ(m,getMapFromMaps(m,"lenv","code"));
-		    return 1;
-		  }else{
-		    map* pmStatus=getMapFromMaps(m,"lenv","status");
-		    setMapInMaps(m,"lenv","gs_location","false");
-		    setMapInMaps(m,"lenv","gs_usid",jobId);
-		    if(pmStatus!=NULL && strncasecmp(pmStatus->value,"Failed",6)==0)
-		      res=createStatus(m,SERVICE_FAILED);
-		    else
-		      if(pmStatus!=NULL  && strncasecmp(pmStatus->value,"Succeeded",9)==0)
-			res=createStatus(m,SERVICE_SUCCEEDED);
-		      else
-			if(pmStatus!=NULL  && strncasecmp(pmStatus->value,"Running",7)==0){
-			  map* tmpMap=getMapFromMaps(m,"lenv","Message");
-			  if(tmpMap!=NULL)
-			    setMapInMaps(m,"lenv","gs_message",tmpMap->value);
-			  res=createStatus(m,SERVICE_STARTED);
-			}
-			else
-			  res=createStatus(m,SERVICE_FAILED);
-		  }
+		  res=printJobStatus(m,jobId);
 		  free(jobId);
 		}
@@ -2530,5 +2506,7 @@
 		    map* testMap=getMapFromMaps(m,"main","memory");
 		    loadHttpRequests(m,request_input_real_format);
-		    dumpMaps(request_input_real_format);
+
+		    if(validateRequest(&m,s1,request_inputs, &request_input_real_format,&request_output_real_format,NULL)<0)
+		      return -1;
 		    loadServiceAndRun (&m, s1, request_inputs,
 				       &request_input_real_format,
@@ -2548,4 +2526,6 @@
 	      }else{
 		loadHttpRequests(m,request_input_real_format);
+		if(validateRequest(&m,s1,request_inputs, &request_input_real_format,&request_output_real_format,NULL)<0)
+		  return -1;
 		loadServiceAndRun (&m,s1,request_inputs,
 				   &request_input_real_format,
@@ -2560,5 +2540,6 @@
 	}
     }
-    if(res!=NULL){
+    map* pmHasPrinted=getMapFromMaps(m,"lenv","hasPrinted");
+    if(res!=NULL && (pmHasPrinted==NULL || strncasecmp(pmHasPrinted->value,"false",5)==0)){
       if(getMapFromMaps(m,"lenv","no-headers")==NULL){
 	printHeaders(m);
@@ -2573,8 +2554,8 @@
 #endif
   }else{
-
     //
     // WPS 1.0.0 and 2.0.0 starts here
     //
+    setMapInMaps(m,"main","executionType","xml");
     //Check for minimum inputs
     map* version=getMap(request_inputs,"version");
@@ -3435,7 +3416,11 @@
   signal (SIGABRT, donothing);
 #endif
+    fprintf(stderr,"%s %d \n",__FILE__,__LINE__);
+    fflush(stderr);
 
   if (((int) zGetpid ()) != cpid || cgiSid != NULL)
     {
+    fprintf(stderr,"%s %d \n",__FILE__,__LINE__);
+    fflush(stderr);
       if (eres == SERVICE_SUCCEEDED)
 #ifdef USE_CALLBACK
@@ -3495,5 +3480,5 @@
       if(cgiSid!=NULL)
 	free(cgiSid);
-      map* tMap=getMapFromMaps(m,"lenv","executionType");
+      map* tMap=getMapFromMaps(m,"main","executionType");
       if(tMap!=NULL && strncasecmp(tMap->value,"xml",3)==0)
 	InternetCloseHandle (&hInternet);
@@ -3524,4 +3509,5 @@
   free (REQUEST);
   free (SERVICE_URL);
+
 #ifdef DEBUG
   fprintf (stderr, "Processed response \n");
